package com.hzs.system.config.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.hzs.common.domain.system.config.BdAwards;
import com.hzs.common.domain.system.config.ext.BdAwardsExt;

import java.util.List;

/**
 * 服务类
 */
public interface IBdAwardsService extends IService<BdAwards> {

    /**
     * 根据国家查询奖衔配置列表
     **/
    List<BdAwards> queryAwards(Integer pkCountry);

    /**
     * 根据pkID查询奖衔信息
     **/
    BdAwards getBdAwardsOne(Integer pkId);

    /**
     * 生成奖衔
     **/
    boolean generate(BdAwards awards);

    /**
     * 修改辅导分红配置
     **/
    boolean updateAwards(BdAwardsExt awardsExt);

    /**
     * 修改环球积分
     **/
    boolean updateLobalIntegral(BdAwardsExt awardsExt);

    /**
     * 修改车奖积分
     **/
    boolean updateGlobalIntegral(BdAwardsExt awardsExt);

    /**
     * 查询所有奖衔
     */
    List<BdAwards> queryAwards();

    /**
     * 查询等级或奖衔是否被使用
     **/
    Integer checkGradeAwards(Long pkRegisterGrade,
                             Long pkSettleGrade,
                             Long pkAwards);

    /**
     * 根据所属国家查询奖衔
     *
     * @param pkCountry
     * @return
     */
    List<BdAwards> queryByPkCountryAwards(Integer pkCountry);

    /**
     * 根据所属国家查询奖衔
     *
     * @param countryList
     * @return
     */
    List<BdAwards> queryAwardsByIdList(List<Integer> countryList);
}
